from kiwoom_blog import *
import sys
import requests
from bs4 import BeautifulSoup
import time
from pandas import DataFrame
import datetime
from datetime import datetime
from tabulate import tabulate
import telegram
import pandas as pd



MARKET_KOSPI   = 0
MARKET_KOSDAQ  = 10

market_list = ['001', '101']
market_dict = {}
kospi_dict = {}
kosdaq_dict = {}

class PyAuto:
    def __init__(self):
        # Kiwoom 클래스의 객체를 생성
        self.kiwoom_blog = Kiwoom()
        self.kiwoom_blog.CommConnect() # 로그인한다.
        # self.kiwoom.GetConditionLoad() # 조건식 가져온다.

    def GetCodeListByMarket(self):
        self.kospi_codes = self.kiwoom_blog.GetCodeListByMarket(MARKET_KOSPI)
        self.kosdaq_codes = self.kiwoom_blog.GetCodeListByMarket(MARKET_KOSDAQ)

    def crawling(self,code):
        now = time.strftime('%H%M%S')
        today = datetime.today().strftime("%Y-%m-%d")
        print("현재시간 : %s" % now)
        keyword = self.kiwoom_blog.GetMasterCodeName(code)
        # 관련도순 : Ar, 최신순 : Add
        alignment = {'관련도순' : '0','최신순' : '1'}
        align = alignment['최신순']       

    # 뉴스기사 가져오기. // 최신것만 가져올 것이므로 최신순 정렬 후 1페이지만 본다.
        response = requests.get("https://search.naver.com/search.naver?where=news&query=" + keyword + "&sm=tab_opt&sort=" + align + "&photo=0&field=0&pd=0&ds=&de=&docid=&related=0&mynews=0&office_type=0&office_section_code=0&news_office_checked=&nso=so%3Ar%2Cp%3Aall&is_sug_officeid=0")
        html = response.text  
        soup_title = BeautifulSoup(html,'html.parser')
        links = soup_title.select(".news_tit") 
        # print(links)

    # 기사의 제목하고 Url만 가져오기
        news_title = []
        news_url = []

        for link in links:
            title = link.text #기사 타이틀 태그 안에 text(제목만)를 가져온다.
            url = link.attrs['href'] #href의 속성값을 가져온다.
            if keyword in title: # 제목에 키워드가 있는것만 뽑아오겠다.
                news_title.append(title)
                news_url.append(url)
                # print(title,url)  
                
                # 본문내용 추출
                # news_content = requests.get(url).content    
                # soup_content= BeautifulSoup(news_content, 'html.parser') # 본문 내용 추출하기                        
                    
    
        df_news = pd.DataFrame({'종목명' : keyword, 'Title': news_title, 'URL': news_url, 'date' : today,'Searchtime' : int(now)})
        if len(df_news) < 1:
            print("%s 관련 핵심기사가 없습니다." % keyword)      
        # print(df_news)
        # print(tabulate(df_news, headers='keys', tablefmt='plain', showindex=True, stralign='left'))

        
        return df_news       


    

    def run(self):    


        self.kospi_codes = self.kiwoom_blog.GetCodeListByMarket(MARKET_KOSPI) ## 리스트
        self.kosdaq_codes = self.kiwoom_blog.GetCodeListByMarket(MARKET_KOSDAQ)  ## 리스트


        for code in self.kospi_codes:
            kospi_dict.update({code : self.kiwoom_blog.GetMasterCodeName(code)})
        for code in self.kosdaq_codes:
            kosdaq_dict.update({code: self.kiwoom_blog.GetMasterCodeName(code)})

        
        # 종목별로 신규 기사 발굴하기
        for code in kospi_dict.keys():
            print("코스피 %s 뉴스기사 크롤링합니다" % kospi_dict[code])
            print(self.crawling(code))
            

        for code in kosdaq_dict.keys():
            print("코스닥 %s 뉴스기사 크롤링합니다" % kosdaq_dict[code])
            print(self.crawling(code))
            




if __name__ == "__main__":
    app = QApplication(sys.argv)
    pyauto = PyAuto()
    pyauto.run()